Loading...
Searching...
No Matches
Finite Impulse Response (FIR) Filters
Signal Processing Functions

## Functions

void | ne10_fir_float_c (const ne10_fir_instance_f32_t *S, ne10_float32_t *pSrc, ne10_float32_t *pDst, ne10_uint32_t blockSize)

## Detailed Description

  This set of functions implements Finite Impulse Response (FIR) filters for floating-point data types. The functions operate on blocks of input and output data and each call to the function processes `blockSize` samples through the filter. `pSrc` and `pDst` points to input and output arrays containing `blockSize` values.

Algorithm:
  The FIR filter algorithm is based upon a sequence of multiply-accumulate (MAC) operations. Each filter coefficient `b[n]` is multiplied by a state variable which equals a previous input sample `x[n]`.

           y[n] = b[0] * x[n] + b[1] * x[n-1] + b[2] * x[n-2] + ...+ b[numTaps-1] * x[n-numTaps+1]

  Finite Impulse Response filter

  `pCoeffs` points to a coefficient array of size `numTaps`. Coefficients are stored in time reversed order.

           {b[numTaps-1], b[numTaps-2], b[N-2], ..., b[1], b[0]}

  `pState` points to a state array of size `numTaps + blockSize - 1`. Samples in the state buffer are stored in the following order.

           {x[n-numTaps+1], x[n-numTaps], x[n-numTaps-1], x[n-numTaps-2]....x[0], x[1], ..., x[blockSize-1]}

  Note that the length of the state buffer exceeds the length of the coefficient array by `blockSize-1`. The increased state buffer length allows circular addressing, which is traditionally used in the FIR filters, to be avoided and yields a significant speed improvement. The state variables are updated after each block of data is processed; the coefficients are untouched.

Instance Structure
  The coefficients and state variables for a filter are stored together in an instance data structure. A separate instance structure must be defined for each filter. Coefficient arrays may be shared among several instances while state variable arrays cannot be shared. There are separate instance structure declarations for each of the 4 supported data types.

Initialization Functions
  There is also an associated initialization function for each data type. The initialization function performs the following operations:
  - Sets the values of the internal structure fields.
  - Zeros out the values in the state buffer.

  Use of the initialization function is optional. However, if the initialization function is used, then the instance structure cannot be placed into a const data section. To place an instance structure into a const data section, the instance structure must be manually initialized. Set the values in the state buffer to zeros before static initialization. The code below statically initializes each of the 4 different data type filter instance structures

      *ne10_fir_instance_f32_t S = {numTaps, pState, pCoeffs};

where `numTaps` is the number of filter coefficients in the filter; `pState` is the address of the state buffer; `pCoeffs` is the address of the coefficient buffer.

Fixed-Point Behavior
  Care must be taken when using the fixed-point versions of the FIR filter functions. In particular, the overflow and saturation behavior of the accumulator used in each function must be considered. Refer to the function specific documentation below for usage guidelines.

## Function Documentation

## ne10_fir_float_c()

void ne10_fir_float_c | ( | const ne10_fir_instance_f32_t * | S,
|  | ne10_float32_t * | pSrc,
|  | ne10_float32_t * | pDst,
|  | ne10_uint32_t | blockSize
| ) |  |

Parameters

  [in] | *S | points to an instance of the floating-point FIR filter structure.
  [in] | *pSrc | points to the block of input data.
  [out] | *pDst | points to the block of output data.
  [in] | blockSize | number of samples to process per call.

Returns
  none.

Definition at line 121 of file NE10_fir.c.